
$(document).ready(function() {
	
	$(".masquer").hide();
	$('#ladescription').html('<h3><img title="Cacher le texte" class="bt_montrer_cacher bt_scale_2" src="images/logo_oeil_visible.png" style="margin-right:10px;" />Le bon dessin</h3><p>Reconnaître les descriptions des images affichées.</p>');
	$(".score").hide();
	genererMenuJeu();
	afficherNbCartes();
	demarrerJeu();
	
	$(".choix").click(function(){
		var choix_clique = $(this).children().attr('data-rep');
		var bonne_image = $('#lacarte img').attr('data-rep');
		var limage = $('#lacarte img').attr('src');
		var cartes_restantes = nb_cartes_choisi;
		var voir_rep_juste = '<div><img style="float:left; margin-right:1em" src="'+limage+'"><div style="font-weight:bold; color:green">'+$(this).html()+'</div><div style="clear:both"></div>';
		var voir_rep_fausse = '<div style="position:relative; min-height:200px"><img class="faux_image" src="'+limage+'"><img class="faux_croix" src="images/logo_barre.png"><div style="font-weight:bold; color:red; margin-left:210px">'+$(this).html()+'</div>';
		if (juste == nb_cartes_choisi-2) cartes_restantes = 'une carte à reconnaître...';
		if (juste < nb_cartes_choisi-2) cartes_restantes = nb_cartes_choisi-1-juste+' cartes à reconnaître...';
		if (choix_clique == bonne_image) {
			//alert('gagné !');
			$('.ecouter').show();
			$('#reponse').modal($('#lareponse').html(voir_rep_juste));
			$('#reponse').modal($('#lepouce').html('<img style="float:right" src="images/logo_pouce_juste.png"> Bravo !<br>Encore '+cartes_restantes));
			juste ++;
			$("#juste").text(juste);
			if (juste != nb_cartes_choisi) {
				afficherCarte();
				$('.choix').show();
			} else {
				//alert('Tu as réussi !');
				$('#reponse').modal('hide');
				var compteur_fin = $('#compteur').text();
				var score_fin = $('#score').text();
				var pouce_haut = $('#juste').text();
				var pouce_bas = $('#faux').text();
				$('#jeu_termine').modal({backdrop:'static'});
				$('#jeu_termine').modal($('#felicitations').html('Félicitations ! <span style="float:right; margin-left:30px;"> '+pouce_bas+' <img src="images/logo_pouce_faux_32.png"></span><span style="float:right;">'+pouce_haut+' <img src="images/logo_pouce_juste_32.png"></span><br>Tu as réussi en '+compteur_fin+' avec un score de '+score_fin+'...<br>'));
				stopCount();
			}
		} else {
			//alert('perdu !');
			$('#reponse').modal($('#lareponse').html(voir_rep_fausse));
			$('#reponse').modal($('#lepouce').html('Dommage ! Essaie encore...'));
			faux ++;
			$("#faux").text(faux);
			$(this).prev().hide();
			$(this).prev().prev().hide();
			$(this).hide();
		}
		score = Math.round(juste*100/(juste+faux)) +'%';
		$("#score").text(score);
	});
	
	$("#rejouer").click(function(){
		$('#jeu_termine').hide();
		window.location.reload();
	});
	
	$('body').on('click', '.ecouter', function () {
		var laDesc = $(this).attr("data-desc");
		// if (laDesc != "" && laDesc != "&nbsp;") responsiveVoice.speak($("#"+laDesc).text(), "French Female");
		if (laDesc != "" && laDesc != "&nbsp;") lire($("#"+laDesc).text(),"fr-FR",1,1);
	});
	
	$('body').on('click', '.ecouter_son', function () {
		var descEnCours = $(this).next().children().attr("data-rep");
		var sonEnCours = "cartes/"+dossierEnCours+"/son"+descEnCours+".mp3";
		jouerSon(sonEnCours);
	});
	
	$('body').on('click', '.bt_montrer_cacher', function () {
		if ($(this).attr('src') == "images/logo_oeil_visible.png") {
			$(this).attr({"src":"images/logo_oeil_barre.png" , "title":"Montrer le texte"});
			// $(this).parent().next().children().fadeOut();
			$(".choix > div").fadeOut();
		} else {
			$(this).attr({"src":"images/logo_oeil_visible.png" , "title":"Cacher le texte"});
			$(".choix > div").fadeIn();
		}
	});
	
}); // Fin $(document).ready(function()


	/* -------------------------------------------------------
	DECLARATION DES VARIABLES
	---------------------------------------------------------- */
	
	var synth = window.speechSynthesis;
	const mesSV = "Pour écouter le texte en synthèse vocale, connecter le poste à Internet et actualiser l'application.";
	var jeuEnCours = new Array();
	var jeu_selectionne = 0;
	var nb_cartes_choisi = 12;
	var compte = 0;
	var temps;
	var timer_is_on = 0;
	var compteur = 0;
	var juste = 0;
	var faux = 0;
	var score = 0;
	var fichierSon = false;
	var dossierEnCours = "";
	
	/* -------------------------------------------------------
	FONCTIONS
	---------------------------------------------------------- */
	
	function demarrerJeu() {
		$(".demarrer").change(function(){
			jeu_selectionne = $("#jeu_selectionne").val();
			nb_cartes_choisi = $("#choix_nb_cartes").val();
			if (jeu_selectionne != '') {
				$(".masquer").show();
				initialiserSerie();
				afficherCarte();
				initialiseCompteur();
			}
		});
	}
	
	function genererMenuJeu() {
		var listedesjeux = '<option value="">Choisis un jeu...</option>';
		for (var i=0; i < tableaudesjeux.length ; i++) {
			listedesjeux += '<option value="'+i+'">'+tableaudesjeux[i][0]+'</option>';
		}
		$("#jeu_selectionne").html(listedesjeux);
	}
	
	function afficherNbCartes() {
		var choix_nb_cartes = '';
		for (var i=10; i > 2 ; i--) {
			choix_nb_cartes += '<option value="'+i+'">'+i+'</option>';
		}		
		$("#choix_nb_cartes").html(choix_nb_cartes);
		$('.ecouter').show();
	}
	
	function initialiserSerie() {
		jeuEnCours = clone(tableaudesjeux[jeu_selectionne][1]);
		var supprpipe=new RegExp("(\\|)", "g");
		for (var i=0; i < jeuEnCours.length ; i++) {
			jeuEnCours[i][0] = '<img data-rep="'+i+'" class="img-responsive" style="margin:auto;" src="cartes/'+jeuEnCours[i][0]+'">';
			jeuEnCours[i][1] = jeuEnCours[i][1].replace(supprpipe,"");
			jeuEnCours[i][1] = '<div data-rep="'+i+'"> '+jeuEnCours[i][1]+'</div>';
		}
		jeuEnCours.shuffle();
		$('#ladescription').html('<h3><img title="Cacher le texte" class="bt_montrer_cacher bt_scale_2" src="images/logo_oeil_visible.png" style="margin-right:10px;" />Le bon portrait</h3><p>Observe l\'image et clique sur la description correspondante.</p>');
		dossierEnCours = tableaudesjeux[jeu_selectionne][1][0][0].split("/");
		dossierEnCours = dossierEnCours[0];
	}
	
	function afficherCarte() {
		$('#lacarte').html(jeuEnCours[0][0]);
		var jeuDesc = new Array();
		jeuDesc.push(jeuEnCours[0][1]);
		jeuEnCours.shift();
		var jeuRestant = clone(jeuEnCours);
		jeuRestant.shuffle();
		jeuDesc.push(jeuRestant[0][1],jeuRestant[1][1]);
		jeuDesc.shuffle();
		$('#desc0').html(jeuDesc[0]);
		$('#desc1').html(jeuDesc[1]);
		$('#desc2').html(jeuDesc[2]);
		$(".ecouter").show();
		$(".ecouter_son").show();
		$(".choix").show();
		if (dossierEnCours[dossierEnCours.length-1] == "s" && dossierEnCours[dossierEnCours.length-2] == "_") fichierSon = true;// le dossier se termine par _s
		else fichierSon = false;
		if (fichierSon == false) {
			$('.ecouter_son').hide();
			$('.choix').css("margin-left","50px");
		} else {
			$('.ecouter_son').show();
			$('.choix').css("margin-left","80px");
		}

	}

	function initialiseCompteur() {
		compte = 0; // met le compteur à zéro
		startCount(); // démarre le compteur
		$("#compteur").text(); // affiche le compteur
		juste = 0;
		$("#juste").text(juste);
		faux = 0;
		$("#faux").text(faux);
		score = 0;
		$("#score").text('');
	}
	
	/* -----------------------------------------------------------
	Compteur
	--------------------------------------------------------------*/

	function timedCount() {
		var secondes=new Date();
		secondes.setTime(compte*1000);
		var lesMinutes = secondes.getMinutes();
		var lesSecondes = secondes.getSeconds();
		lesMinutes=lesMinutes.toString().replace(/^(\d)$/,'0$1')
		lesSecondes=lesSecondes.toString().replace(/^(\d)$/,'0$1')
		var compteur= lesMinutes+":"+lesSecondes;
		$("#compteur").text(compteur);
		compte = compte + 1;
		temps = setTimeout(function(){ timedCount() }, 1000);
	}

	function startCount() {
		if (!timer_is_on) {
			timer_is_on = 1;
			timedCount();
		}
	}

	function stopCount() {
		clearTimeout(temps);
		timer_is_on = 0;
	}
	
	/* -----------------------------------------------------------
	Mélanger les éléments d'un tableau
	http://fr.openclassrooms.com/forum/sujet/javascript-melanger-les-valeurs-d-un-array-80382
	--------------------------------------------------------------*/

	function randomInt(mini, maxi)
	{
		 var nb = mini + (maxi+1-mini)*Math.random();
		 return Math.floor(nb);
	}
	 
	Array.prototype.shuffle = function(n)
	{
		 if(!n)
			  n = this.length;
		 if(n > 1)
		 {
			  var i = randomInt(0, n-1);
			  var tmp = this[i];
			  this[i] = this[n-1];
			  this[n-1] = tmp;
			  this.shuffle(n-1);
		 }
	}
	
	/*   , */
	
	/* -----------------------------------------------------------
	Cloner un tableau en coupant le lien avec l'original 
	https://davidwalsh.name/javascript-clone
	--------------------------------------------------------------*/
	
	function clone(src) {
		function mixin(dest, source, copyFunc) {
			var name, s, i, empty = {};
			for(name in source){
				// the (!(name in empty) || empty[name] !== s) condition avoids copying properties in "source"
				// inherited from Object.prototype.	 For example, if dest has a custom toString() method,
				// don't overwrite it with the toString() method that source inherited from Object.prototype
				s = source[name];
				if(!(name in dest) || (dest[name] !== s && (!(name in empty) || empty[name] !== s))){
					dest[name] = copyFunc ? copyFunc(s) : s;
				}
			}
			return dest;
		}

		if(!src || typeof src != "object" || Object.prototype.toString.call(src) === "[object Function]"){
			// null, undefined, any non-object, or function
			return src;	// anything
		}
		if(src.nodeType && "cloneNode" in src){
			// DOM Node
			return src.cloneNode(true); // Node
		}
		if(src instanceof Date){
			// Date
			return new Date(src.getTime());	// Date
		}
		if(src instanceof RegExp){
			// RegExp
			return new RegExp(src);   // RegExp
		}
		var r, i, l;
		if(src instanceof Array){
			// array
			r = [];
			for(i = 0, l = src.length; i < l; ++i){
				if(i in src){
					r.push(clone(src[i]));
				}
			}
			// we don't clone functions for performance reasons
			//		}else if(d.isFunction(src)){
			//			// function
			//			r = function(){ return src.apply(this, arguments); };
		}else{
			// generic objects
			r = src.constructor ? new src.constructor() : {};
		}
		return mixin(r, src, clone);
	}
	
/* Jouer un son */
var sonEC = new Audio();
function jouerSon(son) { 
	if (sonEC.currentTime != 0 && sonEC.currentTime != sonEC.duration) {
		sonEC.pause();
		sonEC.currentTime = 0;
	} else {
		sonEC.src = son;
		sonEC.play();
	}
}

function lire(texte,lang,rate,pitch) {
	if (texte !== '' && !synth.speaking) {
		// alert("pitch ou prodosie : "+pitch+"\nrate ou débit : "+rate);
		var utterThis = new SpeechSynthesisUtterance(texte);
		utterThis.onend = function (event) {
			// console.log('SpeechSynthesisUtterance.onend');
		};
		utterThis.onerror = function (event) {
			// console.error('SpeechSynthesisUtterance.onerror');
		};
		utterThis.lang = lang;
		utterThis.rate = rate;// débit
		utterThis.pitch = pitch;// prodosie
		synth.speak(utterThis);
	} else synth.cancel();
}
