
$(document).ready(function() {
	
	$(".masquer").hide();
	$(".bt_choix").hide();
	$("#imprimer").hide();
	$("#copier").hide();
	$('#ladescription').html(info0);
	$('#choix_nb_cartes').hide();
	genererMenuJeu();
	afficherNbCartes();
	
	$("#images").click(function(){
		if (jeu_selectionne != '') afficherImages();
		else alert('Oups ! Il faut choisir une série....');
	});
	
	$("#images_descriptions").click(function(){
		if (jeu_selectionne != '') afficherImagesDescriptions();
		else alert('Oups ! Il faut choisir une série....');
	});
	
	$("#images_descriptions_aleatoires").click(function(){
		if (jeu_selectionne != '') afficherImagesDescriptionsAleatoires();
		else alert('Oups ! Il faut choisir une série....');
	});
	
	$("#descriptions_completer").click(function(){
		if (jeu_selectionne != '') afficherDescriptionsCompleter();
		else alert('Oups ! Il faut choisir une série....');
	});
	
	$("#images").mouseover(function(){
		$('#ladescription').html('<h3>Supports d\'activités</h3><p>Visualiser et imprimer les images de la série.</p>');
	});
	$("#images").mouseout(function(){
		$('#ladescription').html(info0);
	});
	$("#images_descriptions").mouseover(function(){
		$('#ladescription').html('<h3>Supports d\'activités</h3><p>Visualiser et imprimer les images et les descriptions de la série.</p>');
	});
	$("#images_descriptions").mouseout(function(){
		$('#ladescription').html(info0);
	});
	$("#images_descriptions_aleatoires").mouseover(function(){
		$('#ladescription').html('<h3>Supports d\'activités</h3><p>Générer des exercices imprimables dans lesquels il faut associer chaque image à sa description.');
	});
	$("#images_descriptions_aleatoires").mouseout(function(){
		$('#ladescription').html(info0);
	});
	$("#descriptions_completer").mouseover(function(){
		$('#ladescription').html('<h3>Supports d\'activités</h3><p>Générer des exercices à trous imprimables.</p>');
	});
	$("#descriptions_completer").mouseout(function(){
		$('#ladescription').html(info0);
	});
	
	$("#choix_nb_cartes").change(function(){
		$('.masquer').hide();
		$("#imprimer").hide();
		$("#copier").hide();
	});
	
	


	
}); // Fin $(document).ready(function()


	/* -------------------------------------------------------
	DECLARATION DES VARIABLES
	---------------------------------------------------------- */
	
	var info0 = '<h3>Supports d\'activités</h3><p>Visualiser et imprimer les séries pour mettre en place des situations pédagogiques non numériques.</p>';
	var jeuEnCours = new Array();
	var jeuEnCoursSansPipe = new Array();
	var jeuEnCoursMelange = new Array();
	var jeuEnCoursSansPipeMelange = new Array();
	var jeu_selectionne = 0;
	var nb_cartes_choisi = 10;
	var supprpipe=new RegExp("(\\|)", "g");

	
	/* -------------------------------------------------------
	FONCTIONS
	---------------------------------------------------------- */
	
	function genererMenuJeu() {
		var listedesjeux = '<option value="">Choisir une série...</option>';
		for (var i=0; i < tableaudesjeux.length ; i++) {
			listedesjeux += '<option value="'+i+'">'+tableaudesjeux[i][0]+'</option>';
		}
		$("#jeu_selectionne").html(listedesjeux);
	}
	
	function afficherNbCartes() {
		$("#jeu_selectionne").change(function(){
			jeu_selectionne = $("#jeu_selectionne").val();
			if (jeu_selectionne != '') {
				var choix_nb_cartes = '';
				for (var i= tableaudesjeux[jeu_selectionne][1].length ; i > 2 ; i--) {
					choix_nb_cartes += '<option value="'+i+'">'+i+'</option>';
				}		
				$("#choix_nb_cartes").html(choix_nb_cartes);
				$('#choix_nb_cartes').show();
				$(".bt_choix").show();
				$(".masquer").hide();
				$("#imprimer").hide();
				$("#copier").hide();
			}
		});
	}
	
	function afficherImages() {
		var jeuEnCours = clone(tableaudesjeux[jeu_selectionne][1]);
		nb_cartes_choisi = $("#choix_nb_cartes").val();
		jeuEnCours = jeuEnCours.slice(0,nb_cartes_choisi);
		var images = '';
		for (var i=0; i < jeuEnCours.length ; i++) {
			images += '<div class="image_avec_numero"><img class="img-responsive" src="cartes/'+jeuEnCours[i][0]+'"><div class="image_numero">'+i+'</div></div>'
		}
		$('.cadre_images').html(images);
		$(".masquer").show();
		$("#imprimer").show();
		$("#copier").show();
	}
	
	function afficherImagesDescriptions() {
		var jeuEnCoursSansPipe = clone(tableaudesjeux[jeu_selectionne][1]);
		nb_cartes_choisi = $("#choix_nb_cartes").val();
		jeuEnCoursSansPipe = jeuEnCoursSansPipe.slice(0,nb_cartes_choisi);
		var images_descriptions = '<table class="table description">';
		for (var i=0; i < jeuEnCoursSansPipe.length ; i++) {
			jeuEnCoursSansPipe[i][1] = jeuEnCoursSansPipe[i][1].replace(supprpipe,"");
			images_descriptions += '<tr>';
			images_descriptions += '<td style="width:120px"><div class="image_avec_numero_tableau"><img class="img-responsive" src="cartes/'+jeuEnCoursSansPipe[i][0]+'"><div class="image_numero_tableau">'+i+'</div></div></td>';
			images_descriptions += '<td>'+jeuEnCoursSansPipe[i][1]+'</td>';
			images_descriptions += '</tr>';
		}
		images_descriptions += '</table>';
		$('.cadre_images').html(images_descriptions);
		$(".masquer").show();
		$("#imprimer").show();
		$("#copier").show();
	}
	
	function afficherImagesDescriptionsAleatoires() {
		var jeuEnCoursSansPipeMelange = clone(tableaudesjeux[jeu_selectionne][1]);
		nb_cartes_choisi = $("#choix_nb_cartes").val();
		jeuEnCoursSansPipeMelange.shuffle();
		jeuEnCoursSansPipeMelange = jeuEnCoursSansPipeMelange.slice(0,nb_cartes_choisi);
		var images_descriptions = '<table class="table description">';
		images_descriptions += '<tr>';
		images_descriptions += '<th style="width:100px">Image</th>';
		images_descriptions += '<th>Description</th>';
		images_descriptions += '</tr>';
		for (var i=0; i < jeuEnCoursSansPipeMelange.length ; i++) {
			jeuEnCoursSansPipeMelange[i][1] = jeuEnCoursSansPipeMelange[i][1].replace(supprpipe,"");
			images_descriptions += '<tr>';
			images_descriptions += '<td></td>';
			images_descriptions += '<td>'+jeuEnCoursSansPipeMelange[i][1]+'</td>';
			images_descriptions += '</tr>';
		}
		images_descriptions += '</table>';
		jeuEnCoursSansPipeMelange.shuffle();
		var images = '';
		for (var i=0; i < jeuEnCoursSansPipeMelange.length ; i++) {
			images += '<div class="image_avec_numero"><img class="img-responsive" src="cartes/'+jeuEnCoursSansPipeMelange[i][0]+'"><div class="image_numero">'+i+'</div></div>'
		}
		$('.cadre_images').html(images_descriptions+'<div style="clear:both; margin-bottom:20px; border-top:solid 1px #CCC"></div>'+images);
		$(".masquer").show();
		$("#imprimer").show();
		$("#copier").show();
	}
	
	function afficherDescriptionsCompleter() {
		var jeuEnCoursMelange = clone(tableaudesjeux[jeu_selectionne][1]);
		nb_cartes_choisi = $("#choix_nb_cartes").val();
		jeuEnCoursMelange.shuffle();
		jeuEnCoursMelange = jeuEnCoursMelange.slice(0,nb_cartes_choisi);
		var descriptions_completer = '<table class="table description">';
		for (var i=0; i < jeuEnCoursMelange.length ; i++) {
			descriptions_completer += '<tr>';
			descriptions_completer += '<td style="width:120px"><div class="image_avec_numero_tableau"><img class="img-responsive" src="cartes/'+jeuEnCoursMelange[i][0]+'"></div></td>';
			
			var tabmot = new Array();
			jeuEnCoursMelange[i][1] = jeuEnCoursMelange[i][1].split('|');
			for (var j=0; j < jeuEnCoursMelange[i][1].length ; j++) {
				if (j%2 == 1) tabmot.push(jeuEnCoursMelange[i][1][j]);
				if (j%2 == 1) jeuEnCoursMelange[i][1][j] = jeuEnCoursMelange[i][1][j].replace(jeuEnCoursMelange[i][1][j], '<span style="color:#CCC">_______________</span>');
			}
			tabmot.sort();
			var ladescription = jeuEnCoursMelange[i][1].join(' ');
			var lesmots = tabmot.join(' ; ');
			descriptions_completer += '<td style="line-height:200%"><i> Mots manquants : '+lesmots+'</i><br />'+ladescription+'</td>';
			descriptions_completer += '</tr>';
		}
		images_descriptions += '</table>';
		$('.cadre_images').html(descriptions_completer);
		$(".masquer").show();
		$("#imprimer").show();
		$("#copier").show();
	}

	
	/* -----------------------------------------------------------
	Mélanger les éléments d'un tableau
	http://fr.openclassrooms.com/forum/sujet/javascript-melanger-les-valeurs-d-un-array-80382
	--------------------------------------------------------------*/

	function randomInt(mini, maxi)
	{
		 var nb = mini + (maxi+1-mini)*Math.random();
		 return Math.floor(nb);
	}
	 
	Array.prototype.shuffle = function(n)
	{
		 if(!n)
			  n = this.length;
		 if(n > 1)
		 {
			  var i = randomInt(0, n-1);
			  var tmp = this[i];
			  this[i] = this[n-1];
			  this[n-1] = tmp;
			  this.shuffle(n-1);
		 }
	}
	
	/* -----------------------------------------------------------
	Cloner un tableau en coupant le lien avec l'original 
	https://davidwalsh.name/javascript-clone
	--------------------------------------------------------------*/
	
	function clone(src) {
		function mixin(dest, source, copyFunc) {
			var name, s, i, empty = {};
			for(name in source){
				// the (!(name in empty) || empty[name] !== s) condition avoids copying properties in "source"
				// inherited from Object.prototype.	 For example, if dest has a custom toString() method,
				// don't overwrite it with the toString() method that source inherited from Object.prototype
				s = source[name];
				if(!(name in dest) || (dest[name] !== s && (!(name in empty) || empty[name] !== s))){
					dest[name] = copyFunc ? copyFunc(s) : s;
				}
			}
			return dest;
		}

		if(!src || typeof src != "object" || Object.prototype.toString.call(src) === "[object Function]"){
			// null, undefined, any non-object, or function
			return src;	// anything
		}
		if(src.nodeType && "cloneNode" in src){
			// DOM Node
			return src.cloneNode(true); // Node
		}
		if(src instanceof Date){
			// Date
			return new Date(src.getTime());	// Date
		}
		if(src instanceof RegExp){
			// RegExp
			return new RegExp(src);   // RegExp
		}
		var r, i, l;
		if(src instanceof Array){
			// array
			r = [];
			for(i = 0, l = src.length; i < l; ++i){
				if(i in src){
					r.push(clone(src[i]));
				}
			}
			// we don't clone functions for performance reasons
			//		}else if(d.isFunction(src)){
			//			// function
			//			r = function(){ return src.apply(this, arguments); };
		}else{
			// generic objects
			r = src.constructor ? new src.constructor() : {};
		}
		return mixin(r, src, clone);
	}
