
$(document).ready(function() {

	$(".masquer").hide();
	$('#ladescription').html('<h3>Qui est-ce ?</h3><p>Retrouver les images correspondant aux descriptions, à la manière du jeu du "Qui est-ce ?".</p>');
	afficherNbCartes();
	genererMenuJeu();
	demarrerJeu();
	
	$('body').on('click', '.case', function () {
		var image_cliquee = $(this).children().attr('id');
		var cartes_restantes = nb_cartes_choisi;
		var voir_rep_juste = '<div><img style="float:left; margin-right:1em" src="cartes/'+image_cliquee+'"><div style="font-weight:bold; color:green">'+$("#ladescription span").html()+'</div><div style="clear:both"></div>';
		var voir_rep_fausse = '<div style="position:relative; min-height:200px"><img class="faux_image" src="cartes/'+image_cliquee+'"><img class="faux_croix" src="images/logo_barre.png"><div style="font-weight:bold; color:red; margin-left:210px">'+$("#ladescription span").html()+'</div>';
		if (juste == nb_cartes_choisi-2) cartes_restantes = 'une carte à trouver...';
		if (juste < nb_cartes_choisi-2) cartes_restantes = nb_cartes_choisi-1-juste+' cartes à trouver...';
		if (!$(this).parent().hasClass('petite')) {
			if (image_cliquee == description_encours) {
				//alert('Gagné !');// instructions à compléter
				$('#reponse').modal($('#lareponse').html(voir_rep_juste));
				$('#reponse').modal($('#lepouce').html('<img style="float:right" src="images/logo_pouce_juste.png"> Bravo !<br>Encore '+cartes_restantes));
				juste ++;
				$("#juste").text(juste);
				if (juste != nb_cartes_choisi) {
					jeuEnCours.shift();
					afficherDescription();
				} else {
					//alert('Tu as réussi !');
					$('#reponse').modal('hide');
					var compteur_fin = $('#compteur').text();
					var score_fin = $('#score').text();
					var pouce_haut = $('#juste').text();
					var pouce_bas = $('#faux').text();
					$('#jeu_termine').modal({backdrop:'static'});
					$('#jeu_termine').modal($('#felicitations').html('Félicitations ! <span style="float:right; margin-left:30px;"> '+pouce_bas+' <img src="images/logo_pouce_faux_32.png"></span><span style="float:right;">'+pouce_haut+' <img src="images/logo_pouce_juste_32.png"></span><br>Tu as réussi en '+compteur_fin+' avec un score de '+score_fin+'...<br>'));
					stopCount();
				}
			} else {
				//alert('Perdu !');
				$('#reponse').modal($('#lareponse').html(voir_rep_fausse));
				$('#reponse').modal($('#lepouce').html('Dommage ! Essaie encore...'));
				faux ++;
				$("#faux").text(faux);
				$(this).parent().css('visibility','hidden');
			}
		}
		score = Math.round(juste*100/(juste+faux)) +'%';
		$("#score").text(score);
	});
	
	$("#rejouer").click(function(){
		$('#jeu_termine').hide();
		window.location.reload();
	});
	
	$('body').on('click', '.bt_cacher', function () {
		$(this).parent().parent().addClass('petite');
		$(this).hide();
		$(this).parent().html('<button type="button" class="btn btn-xs btn-success bt_montrer"><i class="fa fa-eye"></i> Montrer</button>');
	});
	
	$('body').on('click', '.bt_montrer', function () {
		$(this).parent().parent().removeClass('petite');
		$(this).hide();
		$(this).parent().html('<button type="button" class="btn btn-xs btn-info bt_cacher"><i class="fa fa-eye-slash"></i> Cacher</button>');
	});
	
	$('body').on('mouseover', '.case img', function () {
		$(this).addClass('survol_on');
		$('.case img').not($(this)).addClass('survol_autre');
	});
	
	$('body').on('mouseout', '.case img', function () {
		$(this).removeClass('survol_on');
		$('.case img').not($(this)).removeClass('survol_autre');
		$('.case img').addClass('initial');
	});
	
	$('body').on('click', '.ecouter', function () {
		lire(jeuEnCours[0][1],"fr-FR",1,1);
	});
	
	$('body').on('click', '.ecouter_son', function () {
		var sonEnCours = jeuEnCours[0][0].replace("/carte","/son");
		sonEnCours = sonEnCours.replace(".png",".mp3");
		jouerSon("cartes/"+sonEnCours);
	});
	
	$('body').on('click', '.bt_montrer_cacher', function () {
		if ($(this).attr('src') == "images/logo_oeil_visible.png") {
			$(this).attr({"src":"images/logo_oeil_barre.png" , "title":"Montrer le texte"});
			$("#ladescription div span").fadeOut();
		} else {
			$(this).attr({"src":"images/logo_oeil_visible.png" , "title":"Cacher le texte"});
			$("#ladescription div span").fadeIn();
		}
	});
	
}); // Fin $(document).ready(function()


	/* -------------------------------------------------------
	DECLARATION DES VARIABLES
	---------------------------------------------------------- */
	
	var synth = window.speechSynthesis;
	const mesSV = "Pour écouter le texte en synthèse vocale, connecter le poste à Internet et actualiser l'application.";
	var jeuEnCours = new Array(); // le tableau en cours
	var jeu_selectionne = 0;
	var description_encours = '';
	var nb_cartes_choisi = 12;
	var compte = 0;
	var temps;
	var timer_is_on = 0;
	var compteur = 0;
	var juste = 0;
	var faux = 0;
	var score = 0;
	var fichierSon = false;	
	
	/* -------------------------------------------------------
	FONCTIONS
	---------------------------------------------------------- */
	
	function demarrerJeu() {
		$(".demarrer").change(function(){
			recupererJeuSelectionne();
			recupererNbCartes();
			if (jeu_selectionne != '') {
				initialiserSerie();
				afficherCartes();
				afficherDescription();
				initialiseCompteur();
				$(".masquer").show();
			}
		});
	}
	
	function afficherNbCartes() {
		var choix_nb_cartes = '';
		for (var i=12; i > 2 ; i--) {
			choix_nb_cartes += '<option value="'+i+'">'+i+'</option>';
		}		
		$("#choix_nb_cartes").html(choix_nb_cartes);
	}
	
	function recupererNbCartes() {
		nb_cartes_choisi = $("#choix_nb_cartes").val();
	}
	
	function genererMenuJeu() {
		var listedesjeux = '<option value="">Choisis un jeu...</option>';
		for (var i=0; i < tableaudesjeux.length ; i++) {
			listedesjeux += '<option value="'+i+'">'+tableaudesjeux[i][0]+'</option>';
		}
		$("#jeu_selectionne").html(listedesjeux);
	}
	
	function recupererJeuSelectionne() {
		jeu_selectionne = $("#jeu_selectionne").val();
	}
	
	function initialiserSerie() {
		jeuEnCours = tableaudesjeux[jeu_selectionne][1].concat();
		jeuEnCours.shuffle(); // mélange le tableau
		jeuEnCours = jeuEnCours.slice(0,nb_cartes_choisi); // récupère les X premiers éléments du tableau (X étant le nombre de cartes souhaité)
		var indexBarre = jeuEnCours[0][0].indexOf("/");
		if (jeuEnCours[0][0][indexBarre-1] == "s" && jeuEnCours[0][0][indexBarre-2] == "_") fichierSon = true;// le dossier se termine par _s
		else fichierSon = false;
	}
	
	function afficherCartes() {
		var jeuMelange = jeuEnCours.concat();
		jeuMelange.shuffle();// mélange de nouveau le tableau pour que la réponse ne soit pas la systématiquement première image affichée
		var lescartes = '<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 cadre_images">';
		lescartes += '<div class="row">';
		lescartes += '<div class="row-same-height row-full-height" id="lescartes">';
		for (var i=0; i < nb_cartes_choisi ; i++) {
			lescartes += '<div class="col-lg-2 col-md-2 col-sm-2 col-xs-4 emplacement">';
			lescartes += '<div id="case'+i+'" class="case">';
			lescartes += '<img id="'+jeuMelange[i][0]+'" class="img-responsive initial" src="cartes/'+jeuMelange[i][0]+'">';
			lescartes += '</div>';
			lescartes += '<div class="cacher_montrer"><button type="button" class="btn btn-xs btn-info bt_cacher"><i class="fa fa-eye-slash"></i> Cacher</button></div>';
			lescartes += '</div>';
		}
		lescartes += '</div></div></div>';
		$('#lejeu').html(lescartes);
	}
	
	function recupereNbCartes() {
		var choix_nb_cartes = '';
		for (var i=12; i > 2 ; i--) {
			choix_nb_cartes += '<option value="'+i+'">'+i+'</option>';
		}
		$("#choix_nb_cartes").html(choix_nb_cartes);
		nb_cartes_choisi = $("#choix_nb_cartes").val();
	}
		
	function afficherDescription() {
		var supprpipe=new RegExp("(\\|)", "g");
		for (var i=0; i < jeuEnCours.length ; i++) {
			jeuEnCours[i][1] = jeuEnCours[i][1].replace(supprpipe,"");
		}
		if (fichierSon == true) $("#ladescription").html('<div class="'+jeuEnCours[0][0]+'"><img title="Cacher le texte" class="bt_montrer_cacher bt_scale_2" src="images/logo_oeil_visible.png" /> <button title="Ecouter la synthèse vocale" class="ecouter btn btn-info" type="button" style="padding:2px 8px;"><i class=\'fa fa-volume-down fa-lg\'></i></button> <button title="Ecouter l\'enregistrement sonore" class="ecouter_son btn btn-info" type="button" style="padding:2px 8px;"><i class=\'fa fa-headphones fa-lg\'></i></button> <span>'+jeuEnCours[0][1]+'</span></div>');
		else $("#ladescription").html('<div class="'+jeuEnCours[0][0]+'"><img title="Cacher le texte" class="bt_montrer_cacher bt_scale_2" src="images/logo_oeil_visible.png" /> <button title="Ecouter la synthèse vocale" class="ecouter btn btn-info" type="button" style="padding:2px 8px;"><i class=\'fa fa-volume-down fa-lg\'></i></button> <span>'+jeuEnCours[0][1]+'</span></div>');
		description_encours = $("#ladescription div").attr('class');
		$('.emplacement').removeClass('petite');
		$('.cacher_montrer').html('<button type="button" class="btn btn-xs btn-info bt_cacher"><i class="fa fa-eye-slash"></i> Cacher</button>');
		$('.emplacement').css('visibility','visible');
	}

	function initialiseCompteur() {
		compte = 0; // met le compteur à zéro
		startCount(); // démarre le compteur
		$("#compteur").text(); // affiche le compteur
		juste = 0;
		$("#juste").text(juste);
		faux = 0;
		$("#faux").text(faux);
		score = 0;
		$("#score").text('');
	}
	
	/* -----------------------------------------------------------
	Compteur
	--------------------------------------------------------------*/

	function timedCount() {
		var secondes=new Date();
		secondes.setTime(compte*1000);
		var lesMinutes = secondes.getMinutes();
		var lesSecondes = secondes.getSeconds();
		lesMinutes=lesMinutes.toString().replace(/^(\d)$/,'0$1')
		lesSecondes=lesSecondes.toString().replace(/^(\d)$/,'0$1')
		var compteur= lesMinutes+":"+lesSecondes;
		$("#compteur").text(compteur);
		compte = compte + 1;
		temps = setTimeout(function(){ timedCount() }, 1000);
	}

	function startCount() {
		if (!timer_is_on) {
			timer_is_on = 1;
			timedCount();
		}
	}

	function stopCount() {
		clearTimeout(temps);
		timer_is_on = 0;
	}
	
	/* -----------------------------------------------------------
	Mélanger les éléments d'un tableau
	http://fr.openclassrooms.com/forum/sujet/javascript-melanger-les-valeurs-d-un-array-80382
	--------------------------------------------------------------*/

	function randomInt(mini, maxi)
	{
		 var nb = mini + (maxi+1-mini)*Math.random();
		 return Math.floor(nb);
	}
	 
	Array.prototype.shuffle = function(n)
	{
		 if(!n)
			  n = this.length;
		 if(n > 1)
		 {
			  var i = randomInt(0, n-1);
			  var tmp = this[i];
			  this[i] = this[n-1];
			  this[n-1] = tmp;
			  this.shuffle(n-1);
		 }
	}
	
/* Jouer un son */
var sonEC = new Audio();
function jouerSon(son) { 
	if (sonEC.currentTime != 0 && sonEC.currentTime != sonEC.duration) {
		sonEC.pause();
		sonEC.currentTime = 0;
	} else {
		sonEC.src = son;
		sonEC.play();
	}
}

function lire(texte,lang,rate,pitch) {
	if (texte !== '' && !synth.speaking) {
		// alert("pitch ou prodosie : "+pitch+"\nrate ou débit : "+rate);
		var utterThis = new SpeechSynthesisUtterance(texte);
		utterThis.onend = function (event) {
			// console.log('SpeechSynthesisUtterance.onend');
		};
		utterThis.onerror = function (event) {
			// console.error('SpeechSynthesisUtterance.onerror');
		};
		utterThis.lang = lang;
		utterThis.rate = rate;// débit
		utterThis.pitch = pitch;// prodosie
		synth.speak(utterThis);
	} else synth.cancel();
}
